<template>
    <div>
        <ViewField :name="userData.email" title="Емейл" />
        <ViewField :name="userData.name" title="Имя" />
        <router-link
            v-if="userData.quest"
            :to="{
                name: 'AdminQuestView',
                params: { id: userData.quest.id },
            }"
            >Анкета</router-link
        >

        <Selector
            :items="rolesItems"
            text="name"
            name="id"
            v-model="currentRole"
            :disabled="isCurrentUser"
        /><QuestBtn
            @click="sendNewRole"
            :disabled="loading"
            v-if="currentRole !== userData.roles[0].id && !isCurrentUser"
        >
            Назначить
        </QuestBtn>

        <br />
        <br />
    </div>
</template>

<script>
import { mapActions, mapState } from "vuex";
import Selector from "@/components/Selector";
import { textContent } from "@/utils/textContent";
import ViewField from "@/components/Quests/ViewField";
import QuestBtn from "@/components/QuestBtn";
import snackbar from "@/utils/snackbar";

export default {
    name: "UserItem",
    components: { QuestBtn, ViewField, Selector },
    props: { userData: { type: Object, default: () => ({}) } },
    data: () => ({ currentRole: null, loading: false }),
    methods: {
        ...mapActions("admin", ["setRole"]),
        async sendNewRole() {
            try {
                this.loading = true;

                await this.setRole({
                    userId: this.userData.id,
                    role: this.currentRole,
                });
            } catch (e) {
                snackbar(e);
            } finally {
                this.loading = false;
            }
        },
    },
    computed: {
        ...mapState("admin", ["roles"]),
        ...mapState("app", ["user"]),
        rolesItems() {
            return this.roles.map((data) => ({
                ...data,
                name: textContent.roles[data.name],
            }));
        },
        isCurrentUser() {
            return this.userData.id === this.user.id;
        },
    },

    watch: {
        userData: {
            immediate: true,
            handler(userData) {
                this.currentRole = userData.roles[0].id;
            },
        },
    },
};
</script>

<style scoped></style>
